/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	LOステータス更新関連テーブルデータアクセスクラス
//			変更履歴
//				2004.01.08	新規作成	二條智文
//
package jp.co.ntt.lms.lo;

// java AIP
import java.util.*;
import java.sql.*;
import java.sql.SQLException;

import org.apache.commons.lang.StringEscapeUtils;

// XMS API
import jp.co.ntt.lms.xmo.DataAccess;
import jp.co.ntt.lms.xmo.util.*;

/**
 * LOステータス更新関連テーブルデータアクセスクラスです。<BR>
 * @version 0.0.0.1 2004.01.08
 * @author T.Nijou
 */
public class PropagateRelationDataAccess {

	/** テーブル名を保持します */
	private static final String TABLE_NAME = "PropagateRelation";

	/** テーブル定義 */
	private static final String LOID = "LOID";			// LOID
	private static final String RELATEDID = "RelatedID";	// 関連ID

	/**
	 * ステータス更新関連テーブルへ登録処理を行います<BR>
	 * トランザクションの管理は上位で行ってください。
	 * @param strLoID LOID LOID
	 * @param strRelatedID 関連ID
	 * @param objDataAccess データアクセスクラス
	 * @exception SQLException DBエラー
	 */
	private void insert( String strRelatedID, String strLoID, DataAccess objDataAccess )
		throws SQLException
	{

		Hashtable htbData = new Hashtable();
		putData( htbData, LOID, strLoID );
		putData( htbData, RELATEDID, strRelatedID );

		// 登録用SQLを生成します
		String strSQL = objDataAccess.getInsertSQL( htbData, TABLE_NAME );

		// 登録処理を実行
		objDataAccess.execute( strSQL );
	}

	/**
	 * ステータス更新関連テーブルへ登録処理を行います<BR>
	 * 実際の処理はUpdateではなくRelatedIDをキーにして削除を行い登録をします。
	 * トランザクションの管理は上位で行ってください。
	 * @param strLoID LOID LOID
	 * @param strRelatedID 関連ID
	 * @param objDataAccess データアクセスクラス
	 * @exception SQLException DBエラー
	 */
	public void insert( String[] strRelatedID, String strLoID, DataAccess objDataAccess )
		throws SQLException
	{
		// 削除処理
		StringBuffer sbSQL = new StringBuffer();
		sbSQL.append( "DELETE FROM " );
		sbSQL.append( TABLE_NAME );
		sbSQL.append( " WHERE " );
		sbSQL.append( LOID );
		sbSQL.append( "='" );
		sbSQL.append( StringEscapeUtils.escapeSql(strLoID) );
		sbSQL.append( "'" );
		// 削除処理を実行
		objDataAccess.execute( sbSQL.toString() );

		// 登録処理
		for( int i = 0; i < strRelatedID.length; i++ ) {
			insert( strRelatedID[i], strLoID, objDataAccess );
		}
	}

	/**
	 * 削除処理を行います<BR>
	 * LOIDフィールドで指定されたレコードをすべて削除します。
	 * 
	 * @param strLoID LOID
	 * @exception SQLException DBエラー
	 */
	public void deleteLOID( String strLoID, DataAccess objDataAccess )
		throws SQLException
	{
		// SQL文の組立て
		StringBuffer sbSQL = new StringBuffer();
		sbSQL.append( "DELETE FROM " );
		sbSQL.append( TABLE_NAME );
		sbSQL.append( " WHERE " );
		sbSQL.append( LOID );
		sbSQL.append( "='" );
		sbSQL.append( StringEscapeUtils.escapeSql(strLoID) );
		sbSQL.append( "'" );
		// 削除処理を実行
		objDataAccess.execute( sbSQL.toString() );
	}

	/**
	 * 削除処理を行います<BR>
	 * LOID、RelatedID両方のフィールドで指定されたLOIDに関連するレコードはすべて
	 * 削除します。
	 * @param strLoID LOID
	 * @exception SQLException DBエラー
	 */
	public void deleteRelated( String strRelated, DataAccess objDataAccess )
		throws SQLException
	{
		//
		StringBuffer sbSQL = new StringBuffer();
		sbSQL.append( "DELETE FROM " );
		sbSQL.append( TABLE_NAME );
		sbSQL.append( " WHERE " );
		sbSQL.append( RELATEDID );
		sbSQL.append( "='" );
		sbSQL.append( StringEscapeUtils.escapeSql(strRelated) );
		sbSQL.append( "'" );
		// 削除処理を実行
		objDataAccess.execute( sbSQL.toString() );
	}

	/**
	 * 削除処理を行います<BR>
	 * LOID、RelatedID両方のフィールドで指定されたLOIDに関連するレコードはすべて
	 * 削除します。
	 * @param strLoID LOID
	 * @exception SQLException DBエラー
	 */
	public void deleteAll( String strLoID, DataAccess objDataAccess )
		throws SQLException
	{
		//
		StringBuffer sbSQL = new StringBuffer();
		sbSQL.append( "DELETE FROM " );
		sbSQL.append( TABLE_NAME );
		sbSQL.append( " WHERE " );
		sbSQL.append( LOID );
		sbSQL.append( "='" );
		sbSQL.append( StringEscapeUtils.escapeSql(strLoID) );
		sbSQL.append( "' OR " );
		sbSQL.append( RELATEDID );
		sbSQL.append( "='" );
		sbSQL.append( StringEscapeUtils.escapeSql(strLoID) );
		sbSQL.append( "'" );
		// 削除処理を実行
		objDataAccess.execute( sbSQL.toString() );
	}

	/**
	 * LOIDから、ステータス関連LOIDのリストを取得します。<BR>
	 * トランザクションの管理は上位で行ってください。
	 * @param strLoID	LOID
	 * @param objDataAccess データアクセスオブジェクト
	 * @exception SQLException	DBエラー
	 */
	public String[] getRelatedID( String relatedID, DataAccess objDataAccess )
		throws SQLException
	{
		// 検索SQLの作成
		StringBuffer sbSQL = new StringBuffer();
		sbSQL.append( "SELECT " );
		sbSQL.append( LOID );
		sbSQL.append( " FROM " );
		sbSQL.append( TABLE_NAME );
		sbSQL.append( " WHERE " );
		sbSQL.append( RELATEDID );
		sbSQL.append( "='" );
		sbSQL.append( StringEscapeUtils.escapeSql(relatedID) );
		sbSQL.append( "'" );

		ResultSet rs = objDataAccess.executeQuery(sbSQL.toString());

		Vector vecTemp = new Vector();
		while(rs.next()) {
			vecTemp.add( ChangeEncode.setChar(rs.getString( LOID ) ) );
		}
		String[] loIDList = new String[vecTemp.size()];
		vecTemp.copyInto( loIDList );
		return loIDList;
	}

	/**
	 * 安全にHashtableに追加するメソッドです
	 */
	private void putData( Hashtable htbData, String strKey, String strValue ) {
		if( strKey == null || strValue == null ) {
			return;
		}

		if( !strValue.equals( "" ) ) {
			htbData.put( strKey, strValue );
		}
	}

}

